<template>
  <div>
    <mould-search
      ref="searchRef"
      @search="reload"
      :networkCounts="networkCounts"
    >
    </mould-search>
    <!-- 数据表格 -->
    <ele-pro-table
      ref="table"
      :columns="columns"
      :datasource="datasource"
      height="calc(100vh - 500px)"
      full-height="calc(100vh - 115px)"
      tool-class="ele-toolbar-form"
      cache-key="systemOrgUserTable"
      @select="selectChange"
      @select-all="changeSelectAll"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <el-button
          size="small"
          type="primary"
          icon="el-icon-plus"
          class="ele-btn-icon"
          @click="add"
        >
          新建
        </el-button>
        <el-button
          size="small"
          icon="el-icon-download"
          class="ele-btn-icon"
          @click="btnExport"
        >
          导出
        </el-button>
        <el-button
          :disabled="checkRadioData.length == 0"
          size="small"
          icon="el-icon-set-up"
          class="ele-btn-icon"
          @click="allPrinting()"
        >
          打印条码
        </el-button>
      </template>

      <!-- 编码列 -->
      <template v-slot:code="{ row }">
        <el-link type="primary" :underline="false" @click="details(row)">
          {{ row.code }}
        </el-link>
      </template>
      <!-- 牌号列 -->
      <template v-slot:brandNum="{ row }">
        <div>
          {{ row.category.brandNum }}
        </div>
      </template>
      <!-- 型号列 -->
      <template v-slot:modelType="{ row }">
        <div>
          {{ row.category.modelType }}
        </div>
      </template>
      <!-- 分类列 -->
      <template v-slot:categoryLevelPath="{ row }">
        <div>
          {{ row.category.categoryLevelPath }}
        </div>
      </template>

      <!-- 操作列 -->
      <template v-slot:action="{ row }">
        <el-link
          type="primary"
          :underline="false"
          icon="el-icon-edit"
          @click="goEdit(row)"
        >
          编辑
        </el-link>
      </template>
    </ele-pro-table>
    <print ref="printRef"></print>
    <printSr ref="printSrRef"></printSr>
    <printTg ref="printTgRef"></printTg>
  </div>
</template>

<script>
  import print from '@/views/ledgerAssets/components/print.vue';
  import printSr from '@/views/ledgerAssets/components/printSr';
  import printTg from '@/views/ledgerAssets/components/printTg';
  import { getByCode } from '@/api/system/dictionary-data';
  import { businessStatus, networkStatus,sourceStatus } from '@/utils/dict/warehouse';
  import MouldSearch from './mould-search.vue';
  import { getAssetList, downloadAsset } from '@/api/ledgerAssets';
  import dictMixins from '@/mixins/dictMixins';
  import axios from 'axios';
  import {
    API_BASE_URL,
    TOKEN_HEADER_NAME,
    LAYOUT_PATH
  } from '@/config/setting';
  import { download } from '@/utils/file';
  import { getToken, setToken } from '@/utils/token-util';
  export default {
    components: { MouldSearch, print, printSr, printTg },
    mixins: [dictMixins],
    props: {
      // 类别id
      categoryId: [Number, String],
      rootId: [Number, String]
    },
    data() {
      return {
        QRvisible: false,
        businessStatus,
        networkStatus,
        assetLevel: [],
        networkCounts: {},
        isConsumer: false,
        // 表格列配置
        columns: [
          {
            width: 45,
            type: 'selection',
            columnKey: 'selection',
            align: 'center'
          },
          {
            columnKey: 'index',
            type: 'index',
            label: '序号',
            width: 55,
            align: 'center',
            showOverflowTooltip: true,
            fixed: 'left'
          },
          {
            columnKey: 'code',
            prop: 'code',
            slot: 'code',
            label: '编码',
            showOverflowTooltip: true,
            minWidth: 180
          },
          {
            prop: 'name',
            label: '名称',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'fixCode',
            label: '固资编码',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'postName',
            label: '使用岗位',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'codeNumber',
            label: '编号',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'category.modelType',
            label: '型号',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'category.specification',
            label: '规格',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            prop: 'usePerson',
            label: '使用人',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'chargePerson',
            label: '负责人',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'endTime',
            label: '有效期结束时间',
            showOverflowTooltip: true,
            minWidth: 150
          },
          {
            prop: 'source',
            label: '生命周期',
            showOverflowTooltip: true,
            minWidth: 110,
            formatter:(_row)=>{
              return sourceStatus[_row.lifeCycle]

            }
            
          },
          {
            prop: 'level',
            label: '级别',
            showOverflowTooltip: true,
            minWidth: 110,
            formatter: (_row) => {
              if (_row.level) {
                return this.assetLevel.filter(
                  (item) => item.id == _row.level
                )[0].name;
              } else {
                return '';
              }
            }
          },
          {
            prop: 'networkStatus',
            label: '网络状态',
            showOverflowTooltip: true,
            minWidth: 110,
            formatter: (_row) => {
              if (_row.networkStatus) {
                return this.networkStatus.filter(
                  (item) => item.code == _row.networkStatus
                )[0].label;
              } else {
                return '离线';
              }
            }
          },
          {
            prop: 'status',
            label: '状态',
            showOverflowTooltip: true,
            minWidth: 110,
            formatter: (_row) => {
              if (_row.status) {
                return this.businessStatus.filter(
                  (item) => item.code == _row.status
                )[0].label;
              } else {
                return '空闲';
              }
            }
          },
          {
            prop: 'pathName',
            label: '位置',
            showOverflowTooltip: true,
            minWidth: 110,
            formatter: (_row) => {
              const positionDetail =
                _row.position &&
                _row.position.length != 0 &&
                _row.position[0].detailPosition
                  ? _row.position[0].detailPosition
                  : '-';
              return _row.deviceLocationName
                ? _row.deviceLocationName + '-' + positionDetail
                : '';
            }
          },
          {
            columnKey: 'action',
            slot: 'action',
            label: '操作',
            minWidth: 100,
            fixed: 'right'
          }
        ],
        checkRadioData: []
      };
    },
    computed: {
      clientEnvironmentId() {
        return this.$store.state.user.info.clientEnvironmentId;
      }
    },
    created() {
      this.requestDict('生命周期');
      this.getAssetLevelOptions();
    },
    methods: {
      allPrinting() {
        if (this.clientEnvironmentId == 2) {
          this.$refs.printSrRef.open(this.checkRadioData);
        } else if (this.clientEnvironmentId == 3) {
          this.$refs.printTgRef.open(this.checkRadioData);
        } else {
          this.$refs.printRef.open(this.checkRadioData);
        }
      },
      // 全选
      changeSelectAll(arr) {
        console.log(arr);
        if (arr.length != 0) {
          this.checkRadioData = arr;
        } else {
          this.checkRadioData = [];
        }
      },
      selectChange(selection, row) {
        if (selection.length != 0) {
          this.checkRadioData = selection;
        } else {
          this.checkRadioData = [];
        }
      },
      // 获取资产级别下拉
      async getAssetLevelOptions() {
        let { data } = await getByCode('asset_level');
        this.assetLevel =
          data.length > 0
            ? data.map((item) => {
                return {
                  name: Object.keys(item)[0],
                  id: item[Object.keys(item)[0]]
                };
              })
            : [];
      },
      // 跳转到详情页
      add() {
        this.$router.push({
          path: '/ledgerAssets/mould/edit'
        });
      },
      /* 表格数据源 */
      datasource({ page, limit, where, order }) {
        return getAssetList({
          ...where,
          ...order,
          pageNum: page,
          size: limit,
          categoryLevelId: this.categoryId,
          rootCategoryLevelId: this.rootId
        });
      },
      /* 刷新表格 */
      reload(where) {
        this.$refs.table.reload({ pageNum: 1, where: where });
      },

      // 跳转到详情页
      details({ id }) {
        this.$router.push({
          path: '/ledgerAssets/mould/detail',
          query: {
            id
          }
        });
      },
      // 跳转到编辑页
      goEdit({ id }) {
        console.log(id);
        this.$router.push({
          path: '/ledgerAssets/mould/edit',
          query: {
            id
          }
        });
      },

      // 导出
      btnExport() {
        let params = {
          ...this.$refs.searchRef.where,
          exportType: 3,
          categoryLevelId: this.categoryId,
          rootCategoryLevelId: this.rootId
        };
        axios({
          url: `${API_BASE_URL}/main/asset/page/export`,
          method: 'post',
          responseType: 'blob',
          headers: {
            Authorization: getToken()
          },
          data: params
        }).then((res) => {
          download(res.data, '模具台账导出数据');
        });
        // downloadAsset(params, '模具台账导出数据');
      }
    },
    watch: {
      // 监听类别id变化
      categoryId() {
        this.reload();
      }
    }
  };
</script>
<style lang="scss" scoped>
  .ele-btn-icon {
    margin-left: 20px;
  }
</style>
